| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkGeometricErrorMetric Class Reference

Objects that compute geometry-based error during cell tessellation. More...

`#include <vtkGeometricErrorMetric.h>`

Inheritance diagram for vtkGeometricErrorMetric:
[legend]
Collaboration diagram for vtkGeometricErrorMetric:
[legend]

## Public Types
typedef vtkGenericSubdivisionErrorMetric | Superclass
| Standard VTK type and error macros. More...
Public Types inherited from vtkGenericSubdivisionErrorMetric
typedef vtkObject | Superclass
| Standard VTK type and error macros. More...

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkGeometricErrorMetric * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual double | GetAbsoluteGeometricTolerance ()
| Return the squared absolute geometric accuracy. More...
void | SetAbsoluteGeometricTolerance (double value)
| Set the geometric accuracy with a squared absolute value. More...
void | SetRelativeGeometricTolerance (double value, vtkGenericDataSet *ds)
| Set the geometric accuracy with a value relative to the length of the bounding box of the dataset. More...
int | RequiresEdgeSubdivision (double *leftPoint, double *midPoint, double *rightPoint, double alpha) override
| Does the edge need to be subdivided according to the distance between the line passing through its endpoints and the mid point? The edge is defined by its ‘leftPoint’ and its ‘rightPoint’. More...
double | GetError (double *leftPoint, double *midPoint, double *rightPoint, double alpha) override
| Return the error at the mid-point. More...
int | GetRelative ()
| Return the type of output of GetError() More...
Public Member Functions inherited from vtkGenericSubdivisionErrorMetric
vtkGenericSubdivisionErrorMetric * | NewInstance () const
void | SetGenericCell (vtkGenericAdaptorCell *cell)
| The cell that the edge belongs to. More...
virtual vtkGenericAdaptorCell * | GetGenericCell ()
void | SetDataSet (vtkGenericDataSet *ds)
| Set/Get the dataset to be tessellated. More...
virtual vtkGenericDataSet * | GetDataSet ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkGeometricErrorMetric * | New ()
| Construct the error metric with a default squared absolute geometric accuracy equal to 1. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkGeometricErrorMetric * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkGenericSubdivisionErrorMetric
static vtkTypeBool | IsTypeOf (const char *type)
static vtkGenericSubdivisionErrorMetric * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkGeometricErrorMetric ()
| ~vtkGeometricErrorMetric () override
double | Distance2LinePoint (double x[3], double y[3], double z[3])
| Square distance between a straight line (defined by points x and y) and a point z. More...
Protected Member Functions inherited from vtkGenericSubdivisionErrorMetric
| vtkGenericSubdivisionErrorMetric ()
| ~vtkGenericSubdivisionErrorMetric () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | AbsoluteGeometricTolerance
double | SmallestSize
int | Relative
Protected Attributes inherited from vtkGenericSubdivisionErrorMetric
vtkGenericAdaptorCell * | GenericCell
vtkGenericDataSet * | DataSet
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Objects that compute geometry-based error during cell tessellation.

It is a concrete error metric, based on a geometric criterium: the variation of the edge from a straight line.

See also
  vtkGenericCellTessellator vtkGenericSubdivisionErrorMetric

Definition at line 36 of file vtkGeometricErrorMetric.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkGenericSubdivisionErrorMetric vtkGeometricErrorMetric::Superclass

Standard VTK type and error macros.

Definition at line 49 of file vtkGeometricErrorMetric.h.

## Constructor & Destructor Documentation

## ◆ vtkGeometricErrorMetric()

vtkGeometricErrorMetric::vtkGeometricErrorMetric | ( |  | ) |
| protected

## ◆ ~vtkGeometricErrorMetric()

vtkGeometricErrorMetric::~vtkGeometricErrorMetric | ( |  | ) |
| override protected

## Member Function Documentation

## ◆ New()

static vtkGeometricErrorMetric* vtkGeometricErrorMetric::New | ( |  | ) |
| static

Construct the error metric with a default squared absolute geometric accuracy equal to 1.

## ◆ IsTypeOf()

static vtkTypeBool vtkGeometricErrorMetric::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkGeometricErrorMetric::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkGenericSubdivisionErrorMetric.

## ◆ SafeDownCast()

static vtkGeometricErrorMetric* vtkGeometricErrorMetric::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkGeometricErrorMetric::NewInstanceInternal | ( |  | ) | const
| protected virtual

Reimplemented from vtkGenericSubdivisionErrorMetric.

## ◆ NewInstance()

vtkGeometricErrorMetric* vtkGeometricErrorMetric::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkGeometricErrorMetric::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkGenericSubdivisionErrorMetric.

## ◆ GetAbsoluteGeometricTolerance()

virtual double vtkGeometricErrorMetric::GetAbsoluteGeometricTolerance | ( |  | ) |
| virtual

Return the squared absolute geometric accuracy.

See SetAbsoluteGeometricTolerance() for details.

Postcondition
  positive_result: result>0

## ◆ SetAbsoluteGeometricTolerance()

void vtkGeometricErrorMetric::SetAbsoluteGeometricTolerance | ( | double | value | ) |

Set the geometric accuracy with a squared absolute value.

This is the geometric object-based accuracy. Subdivision will be required if the square distance between the real point and the straight line passing through the vertices of the edge is greater than ‘value’. For instance 0.01 will give better result than 0.1.

Precondition
  positive_value: value>0

## ◆ SetRelativeGeometricTolerance()

void vtkGeometricErrorMetric::SetRelativeGeometricTolerance | ( | double | value,
|  | vtkGenericDataSet * | ds
| ) |  |

Set the geometric accuracy with a value relative to the length of the bounding box of the dataset.

Internally compute the absolute tolerance. For instance 0.01 will give better result than 0.1.

Precondition
  valid_range_value: value>0 && value<1
  ds_exists: ds!=0

## ◆ RequiresEdgeSubdivision()

int vtkGeometricErrorMetric::RequiresEdgeSubdivision | ( | double * | leftPoint,
|  | double * | midPoint,
|  | double * | rightPoint,
|  | double | alpha
| ) |  |
| override virtual

Does the edge need to be subdivided according to the distance between the line passing through its endpoints and the mid point? The edge is defined by its ‘leftPoint’ and its ‘rightPoint’.

‘leftPoint’, ‘midPoint’ and ‘rightPoint’ have to be initialized before calling RequiresEdgeSubdivision(). Their format is global coordinates, parametric coordinates and point centered attributes: xyx rst abc de... ‘alpha’ is the normalized abscissa of the midpoint along the edge. (close to 0 means close to the left point, close to 1 means close to the right point)

Precondition
  leftPoint_exists: leftPoint!=0
  midPoint_exists: midPoint!=0
  rightPoint_exists: rightPoint!=0
  clamped_alpha: alpha>0 && alpha<1
  valid_size: sizeof(leftPoint)=sizeof(midPoint)=sizeof(rightPoint) =GetAttributeCollection()->GetNumberOfPointCenteredComponents()+6

Implements vtkGenericSubdivisionErrorMetric.

## ◆ GetError()

double vtkGeometricErrorMetric::GetError | ( | double * | leftPoint,
|  | double * | midPoint,
|  | double * | rightPoint,
|  | double | alpha
| ) |  |
| override virtual

Return the error at the mid-point.

It will return an error relative to the bounding box size if GetRelative() is true, a square absolute error otherwise. See RequiresEdgeSubdivision() for a description of the arguments.

Precondition
  leftPoint_exists: leftPoint!=0
  midPoint_exists: midPoint!=0
  rightPoint_exists: rightPoint!=0
  clamped_alpha: alpha>0 && alpha<1
  valid_size: sizeof(leftPoint)=sizeof(midPoint)=sizeof(rightPoint) =GetAttributeCollection()->GetNumberOfPointCenteredComponents()+6

Postcondition
  positive_result: result>=0

Implements vtkGenericSubdivisionErrorMetric.

## ◆ GetRelative()

int vtkGeometricErrorMetric::GetRelative | ( |  | ) |

Return the type of output of GetError()

## ◆ Distance2LinePoint()

double vtkGeometricErrorMetric::Distance2LinePoint | ( | double | x[3],
|  | double | y[3],
|  | double | z[3]
| ) |  |
| protected

Square distance between a straight line (defined by points x and y) and a point z.

Property: if x and y are equal, the line is a point and the result is the square distance between points x and z.

## Member Data Documentation

## ◆ AbsoluteGeometricTolerance

double vtkGeometricErrorMetric::AbsoluteGeometricTolerance
| protected

Definition at line 133 of file vtkGeometricErrorMetric.h.

## ◆ SmallestSize

double vtkGeometricErrorMetric::SmallestSize
| protected

Definition at line 134 of file vtkGeometricErrorMetric.h.

## ◆ Relative

int vtkGeometricErrorMetric::Relative
| protected

Definition at line 135 of file vtkGeometricErrorMetric.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkGeometricErrorMetric.h